var bettergmail2_bundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var bettergmail2_usLabels = bettergmail2_bundle.createBundle("chrome://bettergmail2/locale/userscript.properties");


var bettergmail2_tabs = {
	GENERAL:0 ,	MESSAGES:1 ,	COMPOSE:2 ,	SIDEBAR:3   
}


function bettergmail2_userScript(id, enabled, full_name, author, homepage, filename, description, enabled_by_default, tab, conflicts ) {
	this.id = id;
	this.enabled = enabled;
	this.full_name = full_name;
	this.author = author;
	this.homepage = homepage;
	this.filename = filename;
	this.description = description;
	this.enabled_by_default = enabled_by_default;
	this.tab = tab;
	this.conflicts = conflicts;
}


function bettergmail2_makeNewUserScript(id, author, homepage, enabled_by_default, tab ) {
	//alert("making " + id);
	return new bettergmail2_userScript(id, 
				 bettergmail2_getOrElseSet(id, enabled_by_default), 
				 bettergmail2_usLabels.GetStringFromName(id+"_title"), 
				author, 
				homepage, 
				id+".user.js",
				 bettergmail2_usLabels.GetStringFromName(id+"_desc"),
				enabled_by_default,
				tab,
				null,
				null);
}

function bettergmail2_makeNewUserScriptWithConflicts(id, author, homepage, enabled_by_default, tab, conflicts) {
	return new bettergmail2_userScript(id, 
				 bettergmail2_getOrElseSet(id, enabled_by_default), 
				 bettergmail2_usLabels.GetStringFromName(id+"_title"), 
				author, 
				homepage, 
				id+".user.js",
				 bettergmail2_usLabels.GetStringFromName(id+"_desc"),
				enabled_by_default,
				tab,
				conflicts,
				null);
}

function bettergmail2_makeNewSkin(id, author, homepage ) {
	return new bettergmail2_userScript(id, 
				 bettergmail2_getOrElseSet(id, false), 
				 bettergmail2_usLabels.GetStringFromName(id+"_title"), 
				author, 
				homepage, 
				id+".user.js",
				 bettergmail2_usLabels.GetStringFromName(id+"_desc"),
				false,
				 bettergmail2_tabs.SKINS,
				null,
				null);
}


function bettergmail2_getOrElseSet(script, defaultValue) {
	var k = "bettergmail2.enabled." + script ;
	
	if ( ! bettergmail2_isPreferenceSet(k) ) {
		 bettergmail2_setBooleanPreference(k,  defaultValue);
	} 		
	return bettergmail2_getBooleanPreference(k);

}

var bettergmail2_scripts = new Array(

					new bettergmail2_makeNewUserScript('addrowhighlights', 
					'stasnikiforov', 
					'http://userstyles.org/styles/4725', 
					true,
					 bettergmail2_tabs.MESSAGES),				 
				 
					new bettergmail2_makeNewUserScript('attachmenticons', 
					'Moktoipas', 
					'http://userstyles.org/style/show/226', 
					true,
					 bettergmail2_tabs.MESSAGES),				 
				 
					new bettergmail2_makeNewUserScript('bottompostinreply', 
					'Henrik N. and Rob Wilkerson', 
					'http://userscripts.org/scripts/show/14256', 
					false,
					 bettergmail2_tabs.COMPOSE),				 
				 
					new bettergmail2_makeNewUserScript('filterassistant', 
					'Ming (Amos) Zhang', 
					'http://userscripts.org/scripts/show/7997', 
					false,
					 bettergmail2_tabs.MESSAGES),				 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('folders4gmail', 
					'Arend v. Reinersdorff', 
					'http://www.arend-von-reinersdorff.com/folders4gmail/', 
					false,
					 bettergmail2_tabs.SIDEBAR,
					 new Array('folders4gmailredesigned','labellinks4gmail') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('folders4gmailredesigned', 
					'Arend v. Reinersdorff, Modified by St. John Johnson', 
					'http://userscripts.org/scripts/show/30394', 
					false,
					 bettergmail2_tabs.SIDEBAR,
					 new Array('folders4gmail','labellinks4gmail') ),		 
				 
					new bettergmail2_makeNewUserScript('forceencrypted', 
					'Mark Pilgrim', 
					'http://userscripts.org/scripts/show/1404', 
					false,
					 bettergmail2_tabs.GENERAL),				 
				 
					new bettergmail2_makeNewUserScript('hidechat', 
					'Diego Barros', 
					'http://userstyles.org/styles/7897', 
					false,
					 bettergmail2_tabs.SIDEBAR),				 
				 
					new bettergmail2_makeNewUserScript('hideinvitesbox', 
					'stasnikiforov', 
					'http://userstyles.org/styles/4724', 
					true,
					 bettergmail2_tabs.SIDEBAR),				 
				 
					new bettergmail2_makeNewUserScript('hidespamcount', 
					'Arend v. Reinersdorff', 
					'http://userscripts.org/scripts/show/22660', 
					false,
					 bettergmail2_tabs.SIDEBAR),				 
				 
					new bettergmail2_makeNewUserScript('inboxcountfirst', 
					'Jon Ramsey, Gina Trapani', 
					'http://userscripts.org/scripts/show/10253', 
					true,
					 bettergmail2_tabs.GENERAL),				 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('labellinks4gmail', 
					'Benjamin Paige III', 
					'http://userscripts.org/scripts/show/30757', 
					false,
					 bettergmail2_tabs.SIDEBAR,
					 new Array('folders4gmailredesigned','folders4gmail') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('macros', 
					'Mihai Parparita', 
					'http://blog.persistent.info/2007/11/macros-for-new-version-of-gmail.html', 
					false,
					 bettergmail2_tabs.GENERAL,
					 new Array('macrosmodified') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('macrosmodified', 
					'Mihai Parparita, modified by Brent Nef', 
					'http://userscripts.org/scripts/show/14189', 
					false,
					 bettergmail2_tabs.GENERAL,
					 new Array('macros') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('showbccautomatically', 
					'Gina Trapani', 
					'http://lifehacker.com/393844/', 
					false,
					 bettergmail2_tabs.COMPOSE,
					 new Array('showbcctrlshiftb') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('showbccctrlshiftv', 
					'Gina Trapani', 
					'http://lifehacker.com/393844/', 
					false,
					 bettergmail2_tabs.COMPOSE,
					 new Array('showbccautomatically') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('showccautomatically', 
					'Gina Trapani', 
					'http://lifehacker.com/393844/', 
					false,
					 bettergmail2_tabs.COMPOSE,
					 new Array('showccctrlshiftc') ),		 
				 
			new bettergmail2_makeNewUserScriptWithConflicts('showccctrlshiftc', 
					'Gina Trapani', 
					'http://lifehacker.com/393844/', 
					false,
					 bettergmail2_tabs.COMPOSE,
					 new Array('showcccautomatically') ),		 
				 
					new bettergmail2_makeNewUserScript('showcollapsiblecalendarandreader', 
					'Michael A. Balazs', 
					'http://userscripts.org/scripts/show/36028', 
					false,
					 bettergmail2_tabs.GENERAL),				 
				 
					new bettergmail2_makeNewUserScript('showeditablesubject', 
					'Gina Trapani', 
					'http://lifehacker.com/5060791/', 
					false,
					 bettergmail2_tabs.COMPOSE),				 
				 
					new bettergmail2_makeNewUserScript('showmessagedetails', 
					'Michael Lieberman', 
					'http://userscripts.org/scripts/show/13700', 
					false,
					 bettergmail2_tabs.MESSAGES)  				 
				 
	

);


var bettergmail2_enabledScripts = null;

function bettergmail2_getEnabledScripts( bettergmail2_scripts) {
	 bettergmail2_enabledScripts = new Array();
	for (var i = 0; i < bettergmail2_scripts.length; i++) {
		if ( bettergmail2_getBooleanPreference("bettergmail2.enabled."+ bettergmail2_scripts[i].id) ) {
			 bettergmail2_enabledScripts.push( bettergmail2_scripts[i]);
			//alert( bettergmail2_scripts[i].id + "enabled");
		}
	}

	 bettergmail2_setBooleanPreference("bettergmail2.loaded",  true);
}

 bettergmail2_getEnabledScripts( bettergmail2_scripts);



function bettergmail2_isScriptApplicable(script, href) {
	var result = false;
	switch (script) {
			case 'addrowhighlights':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'attachmenticons':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'bottompostinreply':  result = ( /https:\/\/mail\.google\.com\/.*/.test(href) || /http:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'filterassistant':  result = ( /https:\/\/mail\.google\.com\/.*/.test(href) || /http:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'folders4gmail':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'folders4gmailredesigned':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'forceencrypted':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'hidechat':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'hideinvitesbox':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'hidespamcount':  result = ( /https:\/\/mail\.google\.com\/.*/.test(href) || /http:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'inboxcountfirst':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'labellinks4gmail':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'macros':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'macrosmodified':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showbccautomatically':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showbccctrlshiftv':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showccautomatically':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showccctrlshiftc':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showcollapsiblecalendarandreader':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showeditablesubject':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
			case 'showmessagedetails':  result = ( /http:\/\/mail\.google\.com\/.*/.test(href) || /https:\/\/mail\.google\.com\/.*/.test(href) ) && true; break;
		}	
	return result;
}
